# Mail Trigger

[![PyPI](https://img.shields.io/pypi/v/mailtrigger.svg?color=brightgreen)](https://pypi.org/project/mailtrigger/)
[![Travis](https://travis-ci.com/craftslab/mailtrigger.svg?branch=master)](https://travis-ci.com/craftslab/mailtrigger)
[![Coverage](https://coveralls.io/repos/github/craftslab/mailtrigger/badge.svg?branch=master)](https://coveralls.io/github/craftslab/mailtrigger?branch=master)
[![License](https://img.shields.io/github/license/craftslab/mailtrigger.svg?color=brightgreen)](https://github.com/craftslab/mailtrigger/blob/master/LICENSE)



## Requirements

- Python (3.7+)
- pip
- python-dev



## Installation

On Ubuntu / Mint, install *Mail Trigger* with the following commands:

```bash
sudo apt update
sudo apt install python3-dev python3-pip python3-setuptools
sudo pip install mailtrigger
```

On OS X, install *Mail Trigger* via [Homebrew](https://brew.sh/) (or via [Linuxbrew](https://linuxbrew.sh/) on Linux):

```
TBD
```

On Windows, install *Mail Trigger* with the following commands:

```
pip install -U pywin32
pip install -U PyInstaller
pip install -Ur requirements.txt

pyinstaller --clean --name mailtrigger -F trigger.py
```



## Updating

```bash
pip install mailtrigger --upgrade
```



## Running

```bash
mailtrigger --mailer-config mailer.json --scheduler-config scheduler.json --trigger-config trigger.json
```



## Settings

*Mail Trigger* parameters can be set in the directory [config](https://github.com/craftslab/mailtrigger/blob/master/mailtrigger/config).

An example of configuration in [mailer.json](https://github.com/craftslab/mailtrigger/blob/master/mailtrigger/config/mailer.json):

```
{
  "pop3": {
    "host": "pop.example.com",
    "pass": "pass",
    "port": 995,
    "ssl": true,
    "timeout": 10,
    "user": "user"
  },
  "smtp": {
    "host": "smtp.example.com",
    "pass": "pass",
    "port": 465,
    "ssl": true,
    "timeout": 10,
    "user": "user"
  }
}
```

An example of configuration in [scheduler.json](https://github.com/craftslab/mailtrigger/blob/master/mailtrigger/config/scheduler.json):

```
{
  "interval": 30
}
```

An example of configuration in [trigger.json](https://github.com/craftslab/mailtrigger/blob/master/mailtrigger/config/trigger.json):

```
{
  "gerrit": {
    "filter": [
      {
        "from": "name@example.com",
        "subject": "[trigger]"
      }
    ],
    "server": [
      {
        "host": "localhost",
        "pass": "pass",
        "port": 8080,
        "user": "user"
      }
    ]
  },
  "helper": {
    "filter": [
      {
        "from": "name@example.com",
        "subject": "[trigger]"
      }
    ]
  },
  "jenkins": {
    "filter": [
      {
        "from": "name@example.com",
        "subject": "[trigger]"
      }
    ],
    "server": [
      {
        "host": "localhost",
        "pass": "pass",
        "port": 8081,
        "user": "user"
      }
    ]
  },
  "jira": {
    "filter": [
      {
        "from": "name@example.com",
        "subject": "[trigger]"
      }
    ],
    "server": [
      {
        "host": "localhost",
        "pass": "pass",
        "port": 8082,
        "user": "user"
      }
    ]
  },
  "printer": {
    "file": "output.xlsx",
    "filter": [
      {
        "from": "name@example.com",
        "subject": ""
      }
    ]
  }
}
```



## Usage

### Subject

```
[trigger]: Write your description here
```

**Note: `[trigger]` is the reserved word in subject**



### Recipient

The recipient is mail receiver as *Mail Trigger*.



### Content

#### Gerrit Trigger

```
@gerrit help
@gerrit list
@gerrit restart <host>
@gerrit start <host>
@gerrit stop <host>
@gerrit abandon <host> <commit|changenumber,patchset>
@gerrit restore <host> <commit|changenumber,patchset>
@gerrit review <host> <commit|changenumber,patchset>
@gerrit submit <host> <commit|changenumber,patchset>
@gerrit version <host>
```



#### Jenkins Trigger

```
TBD
```



#### Jira Trigger

```
TBD
```



#### Trigger Help

```
@help
```



## License Apache

Project License can be found [here](https://github.com/craftslab/mailtrigger/blob/master/LICENSE).
